@Echo off
Setlocal
rem debug echo on

::========================================================================
::	"CD on steroids". SD /? for help
    set ^
  VERSION=1.3

::	Version history at the end of this file.
::	More info: https://www.voidtools.com/forum/viewtopic.php?f=4&t=8242
::========================================================================


::________________________________________________________________________
::
::              SETTINGS
::________________________________________________________________________
::
	for /f "delims=" %%a in (%~dp0SpeedDial.ini) do call set %%a
	set QUERY=/ad -n %MAX_ENTRIES% -sort runcount wfn:*%**


::________________________________________________________________________
::
::              INIT
::________________________________________________________________________
::

	set TEMPFILE=%TEMP%\SD_%RANDOM%.deleteme

::	Check if Everything is running
::	Check if WSelect available
::	This will be done later (JIT) as the SpeedDial routines
::	don't need this. (good for speed ;-)


	set PARM=%1


::	ES / Everything error codes
	set ES_ERROR_1=Failed to register window class
	set ES_ERROR_2=Failed to create listening window.
	set ES_ERROR_3=Out of memory
	set ES_ERROR_4=Expected an additional command line option with the specified switch
	set ES_ERROR_5=Failed to create export output file
	set ES_ERROR_6=Unknown switch.
	set ES_ERROR_7=Failed to send Everything IPC a query.
	set ES_ERROR_8=NO Everything IPC window - make sure the Everything search client is running.



::	Prepare %FILTER% for usage in ES command

	REM if not defined FILTER set FILTER=""

	REM ::	"&" is too dangerous; temp replace with "?"
	REM ::	|, ^, < and > are dangerous too. Escape them.
	REM set FILTER=%FILTER:&=?%
	REM set FILTER=%FILTER:^=^^%
	REM set FILTER=%FILTER:|=^|%
	REM set FILTER=%FILTER:<=^<%
	REM set FILTER=%FILTER:>=^>%

	REM ::	Reinsert & back
	REM set FILTER=%FILTER:?=^^^&%
	REM set FILTER=%FILTER:?=^&%

	rem 	::	Strip leading/trailing ""
	rem 	for /f "delims=" %%x in (%FILTER%) DO set FILTER=%%~x



::________________________________________________________________________
::
::              Action!
::________________________________________________________________________
::

	IF .%1. == ..  goto :SYNTAX             :: No parms
	IF .%2. neq .. goto :SYNTAX             :: 2 parms
	IF .%PARM:~0,1%. == ./. goto :SYNTAX    :: first char = /

	
	IF .%PARM%. == .0. (                    :: parm = 0
	  call :LIST_SPEEDDIALS

	) ELSE IF DEFINED SD_%PARM% (     		:: parm is speeddial entry and notnull ;)
	  set SD-ENTRY=%PARM%
	  call :SPEEDDIAL

	) ELSE IF "%PARM:.=%" == "" (			:: parm is only ....
	call :UP
	
	) ELSE IF "%PARM:-=%" == "" (		    :: parm is only -----
	  call :BACK

	) ELSE IF .%PARM:~0,1%. == .-. (		:: parm starts with -
	  goto :SYNTAX

	  ) ELSE IF exist "%~f1\" (		        :: parm is a valid CMD folderpath
	  call :REALFOLDER
	
	) ELSE (                                :: Normal ES query
	  call :ES
	)

	rem	echo EXECUTE = "%EXECUTE%"

::	Clean up
	If defined TEMPFILE del "%TEMPFILE%" 2>nul
	
	endlocal & %EXECUTE%

goto :EOF


 


::========================================================================
::========================================================================
::
::      SUBROUTINES
::
::========================================================================
::========================================================================

::________________________________________________________________________
::
            :LIST_SPEEDDIALS
::________________________________________________________________________
::

	echo.
	echo.Current SpeedDial entries:
	echo.
	for /f "usebackq tokens=2,* delims=_=" %%x in (`set SD_`) DO @echo. [%%x] %%y
	set EXECUTE=REM

goto :EOF



::________________________________________________________________________
::
			:SPEEDDIAL
::________________________________________________________________________
::

	call set FOLDER="%%SD_%SD-ENTRY%%%"
	set EXECUTE=%COMMAND% %FOLDER%

goto :EOF



::________________________________________________________________________
::
			:UP
::________________________________________________________________________
::

	set UP=%PARM:.=\..%
	set UP= %UP:~2%
	set EXECUTE=%COMMAND% %UP%

goto :EOF



::________________________________________________________________________
::
            :BACK
::________________________________________________________________________
::

	set EXECUTE=%PARM:-=popd ^& % REM

goto :EOF



::________________________________________________________________________
::
			:REALFOLDER
::________________________________________________________________________
::

	set EXECUTE=%COMMAND% %PARM%

goto :EOF



::________________________________________________________________________
::
            :ES
::________________________________________________________________________
::
rem echo on

::	Check if WSelect.exe available
	if NOT exist "%WSELECT%" (
		echo.
		echo.   ERROR: "%WSELECT%" not found.
		echo.
		echo.   Change the location of WSelect.exe in the SETTINGS section of the script.
		echo.   Script location: %~f0
		echo.
		set EXECUTE=REM
	goto :EOF
	)



::	Query ES for matching folders
	"%ES%" %QUERY% %FILTER% > "%TEMPFILE%" 

::	Check if Everything running and other problems.
	set ERRORCODE=%ERRORLEVEL%
	If %ERRORCODE% gtr 0 (            :: ES error encountered
		echo.
		echo.   ERRORCODE %ERRORCODE% : Problem with ES.exe ^/ Everything.exe
		call echo.   %%ES_ERROR_%ERRORCODE%%%
		echo.
		set EXECUTE=REM
	goto :EOF
	)

::	Get the number of folders found
	for /f "usebackq tokens=1,* delims=:" %%x in (`findstr /n /r "." "%TEMPFILE%"`) DO (
		set #RESULTS=%%x & set FOLDER=%%y
	)

::	No results: Do nothing
	IF not DEFINED #RESULTS (
		set EXECUTE=REM
		goto :EOF
	)

::	1 result: EXECUTE = cd / pushd folder
	IF %#RESULTS% == 1 (
		set EXECUTE=%COMMAND% "%FOLDER%"
	goto :EOF
	)

::	Multiple results: show selection dialog and select a folder

	for /f "usebackq delims=" %%x in (` ^
      ^""%WSELECT%" "%TEMPFILE%"  ^
       /bg^=%SELECT_BACKGROUNDCOLOR% ^
       /fc^=%SELECT_FOREGROUNDCOLOR% ^
       /fs^=%SELECT_FONTSIZE% ^
       /cmdcenter /quote ^
        "Go to ..." $item ^" `) DO set FOLDER=%%x

	If .%FOLDER%. == ."".  (
		set EXECUTE=REM
	) ELSE (
		set EXECUTE=%COMMAND% %FOLDER%
		::	Increase runcount (= popularity) of the selected fodler
		"%ES%" -inc-run-count %FOLDER% >nul
	)

	del "%TEMPFILE%"

goto :EOF



::________________________________________________________________________
::
			:SYNTAX
::________________________________________________________________________
::
	echo.---------------------------------------------------------------------
	echo.^|        Quickly change directories in CMD             Version %VERSION%  ^| 
	echo.---------------------------------------------------------------------
	echo.
	echo.  %~n0   [partial foldername]
	echo.
	echo.     CD to a folder by entering a partial foldername.
	echo.     If more than one matching folder is found, the first %MAX_ENTRIES% are 
	echo.     shown to choose from (based on popularity). 
	echo.
	echo.     Example: %~n0 m32 to change directory to c:\windows\systeM32
	echo.
	echo.
	echo.  %~n0   [SpeedDial number] or %~n0 0
	echo.
	echo.     CD to a folder by entering it's SpeedDial number
	echo.
	echo.     Example: %~n0 1 to go to C:\Program Files\Everything
	echo.     Entries can be configured in the script itself
	echo.     (%~f0)
	echo.     %~n0 0 shows a list of all SpeedDial entries.
	echo.
	echo.
	echo.  %~n0   ..[...]
	echo.
	echo.     Go x folders up in the directory tree
	echo.
	echo.     Example: %~n0 ..   goes 1 level up
	echo.     Example: %~n0 .... goes 3 levels up
	echo.
	echo.
	echo.  %~n0   -[---]
	echo.
	echo.     Go x folders back in the list of %~n0 folders
	echo.
	echo.     Example: %~n0 -   goes back one folder
	echo.     Example: %~n0 --- goes back 3 folders
	echo.
	echo.
	echo.  When %%COMMAND%% = PUSHD (currently: %COMMAND% ) :
	echo.     You can use the POPD command to go back to the previous folder
	echo.
	echo.     If the folder is a UNC-path, the script will (temporary) map a 
	echo.     free drive-letter to access this folder.
	echo.     POPD will remove this temporary drive mapping.
	echo.

goto :EOF




::========================================================================
::========================================================================

::======    Version 1.3 - 2019-07-07          ============================
::
::  - Added parameter handlin; /something adn -something: show Syntax
::	- Addded searchlimters (exclude cetrain folders; only certain folders)
::	- Combined 3 ES queries into one
::	- Added extar speeddial options. Example: SD win to go to C:\windows
::	- Added extar speeddial 'aliases'. Example: SD pics to go to D:\Data\photos
::	- Moved settings to separate SpeedDial.ini file
::	- Worked around ES -getresultcount so SpeedDial can now work with most.older
::	  Everything and ES versions (tested with Everything 1.4.1.877 and ES 1.1.0.8)
::	- Code optimization




::======    Version 1.2 - 2019-07-05          ============================
::
::  - Add SD -[---] to go (multiple) folder back using popd
::  - Version in help text
::  - Bug in detection of numbers for SpeedDial:
::	  2install was seen as a number too.
::	  New detection method.
::	- Handle non-existing SpeedDial number
::


::======    Version 1.1 - 2019-06-29          ============================
::
::  - Add SpeedDial functionality
::  - REwrite ES search query (wfn:*<QUERY>*) 
::  - Sort by runcount.
::  - When selecting a folder, it's runcount is incremented
::    (causing the most popular folders to be on top)
::	- If valid path (e.g. c:\windows or \tools), go directly to that folder.
::	- Added ..... option to go multiple levels up
::
::========================================================================
